﻿using System;
using System.Text;
using System.Diagnostics;
using System.Net.Http;
using System.Net.Http.Headers;
using System.IO;


namespace esl
{
    class TextTagsREST
    {
        public static readonly string API_KEY = "your_api_key";
	    public static readonly string API_URL = "https://sandbox.esignlive.com/api";

        public static void Main(string[] args)
        {
            string jsonString = "{\"documents\":[{\"id\":\"sample-contract\",\"name\":\"Test Document\",\"extract\":true,\"data\":{\"esl_doc_extract_type\":1}}],\"status\":\"DRAFT\",\"type\":\"PACKAGE\",\"roles\":[{\"id\":\"Signer1\",\"type\":\"SIGNER\",\"signers\":[{\"email\":\"mail32@mailinator.com\",\"firstName\":\"John\",\"lastName\":\"Smith\",\"id\":\"Signer1\"}],\"name\":\"Signer1\"}],\"name\":\"Text Tags Example Package\"}";

            StringContent jsonContent = new StringContent(jsonString, Encoding.UTF8, "application/json");

            byte[] fileByteArray = File.ReadAllBytes("path_to_the_pdf");
            ByteArrayContent content = new ByteArrayContent(fileByteArray);

            content.Headers.ContentDisposition = new ContentDispositionHeaderValue("form-data");
            content.Headers.ContentDisposition.Name = "\"file\"";
            content.Headers.ContentDisposition.FileName = "\"sample_contract_text_tags.docx\"";
            content.Headers.ContentType = new MediaTypeHeaderValue("application/pdf");

            MultipartFormDataContent form = new MultipartFormDataContent();
            form.Add(content, "\"file\"", "\"sample_contract_text_tags.docx\"");
            form.Add(jsonContent, "\"payload\"");

            HttpClient myClient = new HttpClient();
            myClient.DefaultRequestHeaders.Authorization = new AuthenticationHeaderValue("Basic", API_KEY);
            myClient.DefaultRequestHeaders.Add("Accept", "application/json");

            var response = myClient.PostAsync(new Uri(API_URL) + "/packages/", form).Result;
            Debug.WriteLine(response.Content.ReadAsStringAsync().Result);
        }
    }
}
